Index: tests/regressiontests/cache/tests.py
===================================================================
--- tests/regressiontests/cache/tests.py	(revision 16344)
+++ tests/regressiontests/cache/tests.py	(working copy)
@@ -131,7 +131,7 @@
             u'ascii': u'ascii_value',
             u'unicode_ascii': u'Iñtërnâtiônàlizætiøn1',
             u'Iñtërnâtiônàlizætiøn': u'Iñtërnâtiônàlizætiøn2',
-            u'ascii': {u'x' : 1 }
+            u'ascii2': {u'x' : 1 }
             }
         for (key, value) in stuff.items():
             self.cache.set(key, value)
@@ -317,7 +317,7 @@
             u'ascii': u'ascii_value',
             u'unicode_ascii': u'Iñtërnâtiônàlizætiøn1',
             u'Iñtërnâtiônàlizætiøn': u'Iñtërnâtiônàlizætiøn2',
-            u'ascii': {u'x' : 1 }
+            u'ascii2': {u'x' : 1 }
             }
         # Test `set`
         for (key, value) in stuff.items():
Index: tests/regressiontests/multiple_database/tests.py
===================================================================
--- tests/regressiontests/multiple_database/tests.py	(revision 16344)
+++ tests/regressiontests/multiple_database/tests.py	(working copy)
@@ -1612,7 +1612,6 @@
             return model._meta.object_name == 'Pet'
         else:
             return model._meta.object_name != 'Pet'
-        return None
 
 class FixtureTestCase(TestCase):
     multi_db = True
Index: tests/regressiontests/delete_regress/tests.py
===================================================================
--- tests/regressiontests/delete_regress/tests.py	(revision 16344)
+++ tests/regressiontests/delete_regress/tests.py	(working copy)
@@ -54,7 +54,7 @@
         # Delete something using connection 2.
         cursor2 = self.conn2.cursor()
         cursor2.execute('DELETE from delete_regress_book WHERE id=1')
-        self.conn2._commit();
+        self.conn2._commit()
 
         # Now perform a queryset delete that covers the object
         # deleted in connection 2. This causes an infinite loop
Index: tests/regressiontests/syndication/tests.py
===================================================================
--- tests/regressiontests/syndication/tests.py	(revision 16344)
+++ tests/regressiontests/syndication/tests.py	(working copy)
@@ -25,7 +25,7 @@
                 elem.getElementsByTagName(k)[0].firstChild.wholeText, v)
 
     def assertCategories(self, elem, expected):
-        self.assertEqual(set(i.firstChild.wholeText for i in elem.childNodes if i.nodeName == 'category'), set(expected));
+        self.assertEqual(set(i.firstChild.wholeText for i in elem.childNodes if i.nodeName == 'category'), set(expected))
 
 ######################################
 # Feed view
@@ -73,7 +73,7 @@
             'ttl': '600',
             'copyright': 'Copyright (c) 2007, Sally Smith',
         })
-        self.assertCategories(chan, ['python', 'django']);
+        self.assertCategories(chan, ['python', 'django'])
 
         # Ensure the content of the channel is correct
         self.assertChildNodeContent(chan, {
@@ -102,7 +102,7 @@
             'pubDate': pub_date,
             'author': 'test@example.com (Sally Smith)',
         })
-        self.assertCategories(items[0], ['python', 'testing']);
+        self.assertCategories(items[0], ['python', 'testing'])
 
         for item in items:
             self.assertChildNodes(item, ['title', 'link', 'description', 'guid', 'category', 'pubDate', 'author'])
Index: tests/regressiontests/model_regress/tests.py
===================================================================
--- tests/regressiontests/model_regress/tests.py	(revision 16344)
+++ tests/regressiontests/model_regress/tests.py	(working copy)
@@ -48,8 +48,7 @@
             article_text = "ABCDE" * 1000
         )
         a = Article.objects.get(pk=a.pk)
-        self.assertEqual
-        (len(a.article_text), 5000)
+        self.assertEqual(len(a.article_text), 5000)
 
     def test_date_lookup(self):
         # Regression test for #659
Index: tests/regressiontests/forms/localflavor/id.py
===================================================================
--- tests/regressiontests/forms/localflavor/id.py	(revision 16344)
+++ tests/regressiontests/forms/localflavor/id.py	(working copy)
@@ -133,7 +133,6 @@
         invalid = {
             '0123456789': error_invalid,
             '+62-021-3456789': error_invalid,
-            '+62-021-3456789': error_invalid,
             '+62-0812-3456789': error_invalid,
             '0812345678901': error_invalid,
             'foo': error_invalid,
Index: tests/regressiontests/forms/localflavor/ar.py
===================================================================
--- tests/regressiontests/forms/localflavor/ar.py	(revision 16344)
+++ tests/regressiontests/forms/localflavor/ar.py	(working copy)
@@ -92,7 +92,6 @@
             '20-10123456': error_format,
             '20-10123456-': error_format,
              '20-10123456-5': error_invalid,
-            '2-10123456-9': error_format,
              '27-10345678-1': error_invalid,
              u'27-10345678-1': error_invalid,
         }
Index: tests/regressiontests/forms/localflavor/pt.py
===================================================================
--- tests/regressiontests/forms/localflavor/pt.py	(revision 16344)
+++ tests/regressiontests/forms/localflavor/pt.py	(working copy)
@@ -21,7 +21,6 @@
         valid = {
             '917845189': '917845189',
             '91 784 5189': '917845189',
-            '91 784 5189': '917845189',
             '+351 91 111': '+35191111',
             '00351873': '00351873',
         }
Index: tests/regressiontests/generic_views/views.py
===================================================================
--- tests/regressiontests/generic_views/views.py	(revision 16344)
+++ tests/regressiontests/generic_views/views.py	(working copy)
@@ -42,7 +42,7 @@
     """A ListView that doesn't use a model."""
     queryset = [
         {'first': 'John', 'last': 'Lennon'},
-        {'last': 'Yoko',  'last': 'Ono'}
+        {'first': 'Yoko',  'last': 'Ono'}
     ]
     template_name = 'generic_views/list.html'
 
@@ -65,7 +65,7 @@
             allow_empty_first_page=allow_empty_first_page)
 
 class AuthorListCustomPaginator(AuthorList):
-    paginate_by = 5;
+    paginate_by = 5
 
     def get_paginator(self, queryset, page_size, orphans=0, allow_empty_first_page=True):
         return super(AuthorListCustomPaginator, self).get_paginator(
Index: tests/regressiontests/templates/tests.py
===================================================================
--- tests/regressiontests/templates/tests.py	(revision 16344)
+++ tests/regressiontests/templates/tests.py	(working copy)
@@ -1282,7 +1282,7 @@
             'legacyi18n28': ('{% load i18n %}{% blocktrans with anton as a and berta as b %}{{ a }} + {{ b }}{% endblocktrans %}', {'anton': 'α', 'berta': 'β'}, u'α + β'),
 
             # retrieving language information
-            'i18n28': ('{% load i18n %}{% get_language_info for "de" as l %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}', {}, 'de: German/Deutsch bidi=False'),
+            'i18n28_2': ('{% load i18n %}{% get_language_info for "de" as l %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}', {}, 'de: German/Deutsch bidi=False'),
             'i18n29': ('{% load i18n %}{% get_language_info for LANGUAGE_CODE as l %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}', {'LANGUAGE_CODE': 'fi'}, 'fi: Finnish/suomi bidi=False'),
             'i18n30': ('{% load i18n %}{% get_language_info_list for langcodes as langs %}{% for l in langs %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}; {% endfor %}', {'langcodes': ['it', 'no']}, u'it: Italian/italiano bidi=False; no: Norwegian/Norsk bidi=False; '),
             'i18n31': ('{% load i18n %}{% get_language_info_list for langcodes as langs %}{% for l in langs %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}; {% endfor %}', {'langcodes': (('sl', 'Slovenian'), ('fa', 'Persian'))}, u'sl: Slovenian/Sloven\u0161\u010dina bidi=False; fa: Persian/\u0641\u0627\u0631\u0633\u06cc bidi=True; '),
@@ -1298,7 +1298,7 @@
             'invalidstr02': ('{{ var|default_if_none:"Foo" }}', {}, ('','INVALID')),
             'invalidstr03': ('{% for v in var %}({{ v }}){% endfor %}', {}, ''),
             'invalidstr04': ('{% if var %}Yes{% else %}No{% endif %}', {}, 'No'),
-            'invalidstr04': ('{% if var|default:"Foo" %}Yes{% else %}No{% endif %}', {}, 'Yes'),
+            'invalidstr04_2': ('{% if var|default:"Foo" %}Yes{% else %}No{% endif %}', {}, 'Yes'),
             'invalidstr05': ('{{ var }}', {}, ('', ('INVALID %s', 'var'))),
             'invalidstr06': ('{{ var.prop }}', {'var': {}}, ('', ('INVALID %s', 'var.prop'))),
 
@@ -1323,12 +1323,12 @@
                             """),
 
             ### REGROUP TAG ###########################################################
-            'regroup01': ('{% regroup data by bar as grouped %}' + \
-                          '{% for group in grouped %}' + \
-                          '{{ group.grouper }}:' + \
-                          '{% for item in group.list %}' + \
-                          '{{ item.foo }}' + \
-                          '{% endfor %},' + \
+            'regroup01': ('{% regroup data by bar as grouped %}' +
+                          '{% for group in grouped %}' +
+                          '{{ group.grouper }}:' +
+                          '{% for item in group.list %}' +
+                          '{{ item.foo }}' +
+                          '{% endfor %},' +
                           '{% endfor %}',
                           {'data': [ {'foo':'c', 'bar':1},
                                      {'foo':'d', 'bar':1},
@@ -1338,12 +1338,12 @@
                           '1:cd,2:ab,3:x,'),
 
             # Test for silent failure when target variable isn't found
-            'regroup02': ('{% regroup data by bar as grouped %}' + \
-                          '{% for group in grouped %}' + \
-                          '{{ group.grouper }}:' + \
-                          '{% for item in group.list %}' + \
-                          '{{ item.foo }}' + \
-                          '{% endfor %},' + \
+            'regroup02': ('{% regroup data by bar as grouped %}' +
+                          '{% for group in grouped %}' +
+                          '{{ group.grouper }}:' +
+                          '{% for item in group.list %}' +
+                          '{{ item.foo }}' +
+                          '{% endfor %},' +
                           '{% endfor %}',
                           {}, ''),
             ### SSI TAG ########################################################
Index: tests/regressiontests/introspection/tests.py
===================================================================
--- tests/regressiontests/introspection/tests.py	(revision 16344)
+++ tests/regressiontests/introspection/tests.py	(working copy)
@@ -45,7 +45,7 @@
 
     def test_django_table_names(self):
         cursor = connection.cursor()
-        cursor.execute('CREATE TABLE django_ixn_test_table (id INTEGER);');
+        cursor.execute('CREATE TABLE django_ixn_test_table (id INTEGER);')
         tl = connection.introspection.django_table_names()
         cursor.execute("DROP TABLE django_ixn_test_table;")
         self.assertTrue('django_ixn_testcase_table' not in tl,