diff --git a/tests/regressiontests/cache/tests.py b/tests/regressiontests/cache/tests.py
index c5349d5..cf74b74 100644
--- a/tests/regressiontests/cache/tests.py
+++ b/tests/regressiontests/cache/tests.py
@@ -131,7 +131,7 @@ class DummyCacheTests(unittest.TestCase):
             u'ascii': u'ascii_value',
             u'unicode_ascii': u'Iñtërnâtiônàlizætiøn1',
             u'Iñtërnâtiônàlizætiøn': u'Iñtërnâtiônàlizætiøn2',
-            u'ascii': {u'x' : 1 }
+            u'ascii2': {u'x' : 1 }
             }
         for (key, value) in stuff.items():
             self.cache.set(key, value)
@@ -317,7 +317,7 @@ class BaseCacheTests(object):
             u'ascii': u'ascii_value',
             u'unicode_ascii': u'Iñtërnâtiônàlizætiøn1',
             u'Iñtërnâtiônàlizætiøn': u'Iñtërnâtiônàlizætiøn2',
-            u'ascii': {u'x' : 1 }
+            u'ascii2': {u'x' : 1 }
             }
         # Test `set`
         for (key, value) in stuff.items():
diff --git a/tests/regressiontests/delete_regress/tests.py b/tests/regressiontests/delete_regress/tests.py
index 2027780..ec26676 100644
--- a/tests/regressiontests/delete_regress/tests.py
+++ b/tests/regressiontests/delete_regress/tests.py
@@ -54,7 +54,7 @@ class DeleteLockingTest(TransactionTestCase):
         # Delete something using connection 2.
         cursor2 = self.conn2.cursor()
         cursor2.execute('DELETE from delete_regress_book WHERE id=1')
-        self.conn2._commit();
+        self.conn2._commit()
 
         # Now perform a queryset delete that covers the object
         # deleted in connection 2. This causes an infinite loop
diff --git a/tests/regressiontests/forms/localflavor/ar.py b/tests/regressiontests/forms/localflavor/ar.py
index 9c67269..f0416e1 100644
--- a/tests/regressiontests/forms/localflavor/ar.py
+++ b/tests/regressiontests/forms/localflavor/ar.py
@@ -92,7 +92,6 @@ class ARLocalFlavorTests(LocalFlavorTestCase):
             '20-10123456': error_format,
             '20-10123456-': error_format,
              '20-10123456-5': error_invalid,
-            '2-10123456-9': error_format,
              '27-10345678-1': error_invalid,
              u'27-10345678-1': error_invalid,
         }
diff --git a/tests/regressiontests/forms/localflavor/id.py b/tests/regressiontests/forms/localflavor/id.py
index 2e8c510..71a8d9f 100644
--- a/tests/regressiontests/forms/localflavor/id.py
+++ b/tests/regressiontests/forms/localflavor/id.py
@@ -133,7 +133,6 @@ class IDLocalFlavorTests(LocalFlavorTestCase):
         invalid = {
             '0123456789': error_invalid,
             '+62-021-3456789': error_invalid,
-            '+62-021-3456789': error_invalid,
             '+62-0812-3456789': error_invalid,
             '0812345678901': error_invalid,
             'foo': error_invalid,
diff --git a/tests/regressiontests/forms/localflavor/pt.py b/tests/regressiontests/forms/localflavor/pt.py
index b8d784a..333f96d 100644
--- a/tests/regressiontests/forms/localflavor/pt.py
+++ b/tests/regressiontests/forms/localflavor/pt.py
@@ -21,7 +21,6 @@ class PTLocalFlavorTests(LocalFlavorTestCase):
         valid = {
             '917845189': '917845189',
             '91 784 5189': '917845189',
-            '91 784 5189': '917845189',
             '+351 91 111': '+35191111',
             '00351873': '00351873',
         }
diff --git a/tests/regressiontests/generic_views/views.py b/tests/regressiontests/generic_views/views.py
index 9d2770c..0c8fd49 100644
--- a/tests/regressiontests/generic_views/views.py
+++ b/tests/regressiontests/generic_views/views.py
@@ -42,7 +42,7 @@ class DictList(generic.ListView):
     """A ListView that doesn't use a model."""
     queryset = [
         {'first': 'John', 'last': 'Lennon'},
-        {'last': 'Yoko',  'last': 'Ono'}
+        {'first': 'Yoko',  'last': 'Ono'}
     ]
     template_name = 'generic_views/list.html'
 
@@ -65,7 +65,7 @@ class CustomPaginator(Paginator):
             allow_empty_first_page=allow_empty_first_page)
 
 class AuthorListCustomPaginator(AuthorList):
-    paginate_by = 5;
+    paginate_by = 5
 
     def get_paginator(self, queryset, page_size, orphans=0, allow_empty_first_page=True):
         return super(AuthorListCustomPaginator, self).get_paginator(
diff --git a/tests/regressiontests/introspection/tests.py b/tests/regressiontests/introspection/tests.py
index 7481641..e309a98 100644
--- a/tests/regressiontests/introspection/tests.py
+++ b/tests/regressiontests/introspection/tests.py
@@ -45,7 +45,7 @@ class IntrospectionTests(TestCase):
 
     def test_django_table_names(self):
         cursor = connection.cursor()
-        cursor.execute('CREATE TABLE django_ixn_test_table (id INTEGER);');
+        cursor.execute('CREATE TABLE django_ixn_test_table (id INTEGER);')
         tl = connection.introspection.django_table_names()
         cursor.execute("DROP TABLE django_ixn_test_table;")
         self.assertTrue('django_ixn_testcase_table' not in tl,
diff --git a/tests/regressiontests/model_regress/tests.py b/tests/regressiontests/model_regress/tests.py
index a103590..db539f2 100644
--- a/tests/regressiontests/model_regress/tests.py
+++ b/tests/regressiontests/model_regress/tests.py
@@ -48,8 +48,7 @@ class ModelTests(TestCase):
             article_text = "ABCDE" * 1000
         )
         a = Article.objects.get(pk=a.pk)
-        self.assertEqual
-        (len(a.article_text), 5000)
+        self.assertEqual(len(a.article_text), 5000)
 
     def test_date_lookup(self):
         # Regression test for #659
diff --git a/tests/regressiontests/multiple_database/tests.py b/tests/regressiontests/multiple_database/tests.py
index 110ee1e..551a677 100644
--- a/tests/regressiontests/multiple_database/tests.py
+++ b/tests/regressiontests/multiple_database/tests.py
@@ -1612,7 +1612,6 @@ class AntiPetRouter(object):
             return model._meta.object_name == 'Pet'
         else:
             return model._meta.object_name != 'Pet'
-        return None
 
 class FixtureTestCase(TestCase):
     multi_db = True
diff --git a/tests/regressiontests/syndication/tests.py b/tests/regressiontests/syndication/tests.py
index 58e6373..2f90dc0 100644
--- a/tests/regressiontests/syndication/tests.py
+++ b/tests/regressiontests/syndication/tests.py
@@ -25,7 +25,7 @@ class FeedTestCase(TestCase):
                 elem.getElementsByTagName(k)[0].firstChild.wholeText, v)
 
     def assertCategories(self, elem, expected):
-        self.assertEqual(set(i.firstChild.wholeText for i in elem.childNodes if i.nodeName == 'category'), set(expected));
+        self.assertEqual(set(i.firstChild.wholeText for i in elem.childNodes if i.nodeName == 'category'), set(expected))
 
 ######################################
 # Feed view
@@ -73,7 +73,7 @@ class SyndicationFeedTest(FeedTestCase):
             'ttl': '600',
             'copyright': 'Copyright (c) 2007, Sally Smith',
         })
-        self.assertCategories(chan, ['python', 'django']);
+        self.assertCategories(chan, ['python', 'django'])
 
         # Ensure the content of the channel is correct
         self.assertChildNodeContent(chan, {
@@ -102,7 +102,7 @@ class SyndicationFeedTest(FeedTestCase):
             'pubDate': pub_date,
             'author': 'test@example.com (Sally Smith)',
         })
-        self.assertCategories(items[0], ['python', 'testing']);
+        self.assertCategories(items[0], ['python', 'testing'])
 
         for item in items:
             self.assertChildNodes(item, ['title', 'link', 'description', 'guid', 'category', 'pubDate', 'author'])
diff --git a/tests/regressiontests/templates/tests.py b/tests/regressiontests/templates/tests.py
index 1f065f9..a561686 100644
--- a/tests/regressiontests/templates/tests.py
+++ b/tests/regressiontests/templates/tests.py
@@ -1282,7 +1282,7 @@ class Templates(unittest.TestCase):
             'legacyi18n28': ('{% load i18n %}{% blocktrans with anton as a and berta as b %}{{ a }} + {{ b }}{% endblocktrans %}', {'anton': 'α', 'berta': 'β'}, u'α + β'),
 
             # retrieving language information
-            'i18n28': ('{% load i18n %}{% get_language_info for "de" as l %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}', {}, 'de: German/Deutsch bidi=False'),
+            'i18n28_2': ('{% load i18n %}{% get_language_info for "de" as l %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}', {}, 'de: German/Deutsch bidi=False'),
             'i18n29': ('{% load i18n %}{% get_language_info for LANGUAGE_CODE as l %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}', {'LANGUAGE_CODE': 'fi'}, 'fi: Finnish/suomi bidi=False'),
             'i18n30': ('{% load i18n %}{% get_language_info_list for langcodes as langs %}{% for l in langs %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}; {% endfor %}', {'langcodes': ['it', 'no']}, u'it: Italian/italiano bidi=False; no: Norwegian/Norsk bidi=False; '),
             'i18n31': ('{% load i18n %}{% get_language_info_list for langcodes as langs %}{% for l in langs %}{{ l.code }}: {{ l.name }}/{{ l.name_local }} bidi={{ l.bidi }}; {% endfor %}', {'langcodes': (('sl', 'Slovenian'), ('fa', 'Persian'))}, u'sl: Slovenian/Sloven\u0161\u010dina bidi=False; fa: Persian/\u0641\u0627\u0631\u0633\u06cc bidi=True; '),
@@ -1298,7 +1298,7 @@ class Templates(unittest.TestCase):
             'invalidstr02': ('{{ var|default_if_none:"Foo" }}', {}, ('','INVALID')),
             'invalidstr03': ('{% for v in var %}({{ v }}){% endfor %}', {}, ''),
             'invalidstr04': ('{% if var %}Yes{% else %}No{% endif %}', {}, 'No'),
-            'invalidstr04': ('{% if var|default:"Foo" %}Yes{% else %}No{% endif %}', {}, 'Yes'),
+            'invalidstr04_2': ('{% if var|default:"Foo" %}Yes{% else %}No{% endif %}', {}, 'Yes'),
             'invalidstr05': ('{{ var }}', {}, ('', ('INVALID %s', 'var'))),
             'invalidstr06': ('{{ var.prop }}', {'var': {}}, ('', ('INVALID %s', 'var.prop'))),
 
@@ -1323,12 +1323,12 @@ class Templates(unittest.TestCase):
                             """),
 
             ### REGROUP TAG ###########################################################
-            'regroup01': ('{% regroup data by bar as grouped %}' + \
-                          '{% for group in grouped %}' + \
-                          '{{ group.grouper }}:' + \
-                          '{% for item in group.list %}' + \
-                          '{{ item.foo }}' + \
-                          '{% endfor %},' + \
+            'regroup01': ('{% regroup data by bar as grouped %}'
+                          '{% for group in grouped %}'
+                          '{{ group.grouper }}:'
+                          '{% for item in group.list %}'
+                          '{{ item.foo }}'
+                          '{% endfor %},'
                           '{% endfor %}',
                           {'data': [ {'foo':'c', 'bar':1},
                                      {'foo':'d', 'bar':1},
@@ -1338,12 +1338,12 @@ class Templates(unittest.TestCase):
                           '1:cd,2:ab,3:x,'),
 
             # Test for silent failure when target variable isn't found
-            'regroup02': ('{% regroup data by bar as grouped %}' + \
-                          '{% for group in grouped %}' + \
-                          '{{ group.grouper }}:' + \
-                          '{% for item in group.list %}' + \
-                          '{{ item.foo }}' + \
-                          '{% endfor %},' + \
+            'regroup02': ('{% regroup data by bar as grouped %}'
+                          '{% for group in grouped %}'
+                          '{{ group.grouper }}:'
+                          '{% for item in group.list %}'
+                          '{{ item.foo }}'
+                          '{% endfor %},'
                           '{% endfor %}',
                           {}, ''),
             ### SSI TAG ########################################################